<project xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns="http://maven.apache.org/POM/4.0.0" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>

    <groupId>se.jobtechdev</groupId>
    <artifactId>min-inskrivningsstatus-api</artifactId>
    <version>2.0.1</version>
    <packaging>jar</packaging>
    <url>https://jobtechdev.se/en/components/pdg</url>

    <name>Min Inskrivningsstatus API</name>
    <description>Extracts subset information from RASK API</description>

    <parent>
        <groupId>org.springframework.boot</groupId>
        <artifactId>spring-boot-starter-parent</artifactId>
        <version>3.4.3</version>
        <relativePath/> <!-- lookup parent from repository -->
    </parent>

    <properties>
        <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
        <project.reporting.outputEncoding>UTF-8</project.reporting.outputEncoding>
        <java.version>21</java.version>
        <ecs-logging-java.version>1.6.0</ecs-logging-java.version>
        <jackson.version>2.18.3</jackson.version>
        <spring.boot.mainclass>se.jobtechdev.mininskrivningsstatus.api.Main</spring.boot.mainclass>
        <api.spec.version>2.0.0</api.spec.version>
    </properties>

    <dependencies>
        <dependency>
            <groupId>org.springframework.boot</groupId>
            <artifactId>spring-boot-starter-web</artifactId>
        </dependency>

        <dependency>
            <groupId>org.springframework.boot</groupId>
            <artifactId>spring-boot-starter-security</artifactId>
        </dependency>

        <dependency>
            <groupId>org.springframework.boot</groupId>
            <artifactId>spring-boot-starter-test</artifactId>
            <scope>test</scope>
        </dependency>

        <dependency>
            <groupId>jakarta.validation</groupId>
            <artifactId>jakarta.validation-api</artifactId>
            <version>3.1.1</version>
        </dependency>

        <dependency>
            <groupId>io.swagger.core.v3</groupId>
            <artifactId>swagger-annotations-jakarta</artifactId>
            <version>2.2.28</version>
        </dependency>

        <dependency>
            <groupId>javax.xml.bind</groupId>
            <artifactId>jaxb-api</artifactId>
            <version>2.3.1</version>
        </dependency>

        <dependency>
            <groupId>com.fasterxml.jackson.core</groupId>
            <artifactId>jackson-core</artifactId>
            <version>${jackson.version}</version>
        </dependency>

        <dependency>
            <groupId>com.fasterxml.jackson.core</groupId>
            <artifactId>jackson-databind</artifactId>
            <version>${jackson.version}</version>
        </dependency>

        <dependency>
            <groupId>com.fasterxml.jackson.core</groupId>
            <artifactId>jackson-annotations</artifactId>
            <version>${jackson.version}</version>
        </dependency>

        <dependency>
            <groupId>com.fasterxml.jackson.datatype</groupId>
            <artifactId>jackson-datatype-jsr310</artifactId>
            <version>2.18.3</version>
        </dependency>

        <dependency>
            <groupId>org.projectlombok</groupId>
            <artifactId>lombok</artifactId>
            <version>1.18.36</version>
            <scope>provided</scope>
        </dependency>

        <dependency>
            <groupId>co.elastic.logging</groupId>
            <artifactId>logback-ecs-encoder</artifactId>
            <version>${ecs-logging-java.version}</version>
        </dependency>

        <dependency>
            <groupId>net.logstash.logback</groupId>
            <artifactId>logstash-logback-encoder</artifactId>
            <version>8.0</version>
        </dependency>

        <dependency>
            <groupId>org.openapitools</groupId>
            <artifactId>jackson-databind-nullable</artifactId>
            <version>0.2.6</version>
        </dependency>

        <!-- https://mvnrepository.com/artifact/org.apache.httpcomponents.client5/httpclient5 -->
        <dependency>
            <groupId>org.apache.httpcomponents.client5</groupId>
            <artifactId>httpclient5</artifactId>
        </dependency>

        <!-- Security pin: https://mvnrepository.com/artifact/com.google.guava/guava -->
        <dependency>
            <groupId>com.google.guava</groupId>
            <artifactId>guava</artifactId>
            <version>33.4.0-jre</version>
        </dependency>

        <!-- Security pin: https://mvnrepository.com/artifact/org.xmlunit/xmlunit-core -->
        <dependency>
            <groupId>org.xmlunit</groupId>
            <artifactId>xmlunit-core</artifactId>
            <version>2.10.0</version>
            <scope>test</scope>
        </dependency>
    </dependencies>

    <build>
        <plugins>
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-antrun-plugin</artifactId>
                <version>3.1.0</version>
                <executions>
                    <execution>
                        <id>download-files</id>
                        <phase>generate-sources</phase>
                        <goals>
                            <goal>run</goal>
                        </goals>
                        <configuration>
                            <target>
                                <mkdir dir="target/classes/static"/>
                                <get src="https://gitlab.com/arbetsformedlingen/min-inskrivningsstatus/api/specs/-/raw/v${api.spec.version}/openapi.yaml" dest="target/classes/static/" verbose="false" usetimestamp="true"/>
                            </target>
                        </configuration>
                    </execution>
                </executions>
            </plugin>
            <plugin>
                <groupId>org.springframework.boot</groupId>
                <artifactId>spring-boot-maven-plugin</artifactId>
                <version>3.4.3</version>
                <configuration>
                    <mainClass>se.jobtechdev.mininskrivningsstatus.api.Main</mainClass>
                </configuration>
                <executions>
                    <execution>
                        <goals>
                            <goal>repackage</goal>
                        </goals>
                        <configuration>
                            <layers>
                                <enabled>true</enabled>
                                <includeLayerTools>true</includeLayerTools>
                            </layers>
                            <mainClass>se.jobtechdev.mininskrivningsstatus.api.Main</mainClass>
                            <executable>true</executable>
                        </configuration>
                    </execution>
                </executions>
            </plugin>
            <plugin>
                <groupId>org.jacoco</groupId>
                <artifactId>jacoco-maven-plugin</artifactId>
                <version>0.8.12</version>
                <configuration>
                    <excludes>
                        <exclude>**/se/arbetsformedlingen/rask/**</exclude>
                        <exclude>**/se/jobtechdev/mininskrivningsstatus/api/generated/**</exclude>
                    </excludes>
                </configuration>
                <executions>
                    <execution>
                        <id>coverage</id>
                        <goals>
                            <goal>check</goal>
                        </goals>
                        <configuration>
                            <rules>
                                <rule>
                                    <element>PACKAGE</element>
                                    <limits>
                                        <limit>
                                            <counter>INSTRUCTION</counter>
                                            <value>COVEREDRATIO</value>
                                            <minimum>1.0</minimum>
                                        </limit>
                                    </limits>
                                </rule>
                            </rules>
                        </configuration>
                    </execution>
                    <execution>
                        <goals>
                            <goal>prepare-agent</goal>
                        </goals>
                    </execution>
                    <execution>
                        <id>report</id>
                        <phase>prepare-package</phase>
                        <goals>
                            <goal>report</goal>
                        </goals>
                    </execution>
                </executions>
            </plugin>
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-surefire-plugin</artifactId>
                <version>3.5.2</version>
                <executions>
                    <execution>
                        <id>unit</id>
                        <configuration>
                            <groups>UnitTest</groups>
                        </configuration>
                    </execution>
                    <execution>
                        <id>integration</id>
                        <configuration>
                            <groups>IntegrationTest</groups>
                        </configuration>
                    </execution>
                </executions>
            </plugin>
            <plugin>
                <groupId>org.openapitools</groupId>
                <artifactId>openapi-generator-maven-plugin</artifactId>
                <version>7.12.0</version>
                <executions>
                    <execution>
                        <id>min-inskrivningsstatus</id>
                        <goals>
                            <goal>generate</goal>
                        </goals>
                        <configuration>
                            <openapiNormalizer>REF_AS_PARENT_IN_ALLOF=true</openapiNormalizer>
                            <inputSpec>${project.basedir}/target/classes/static/openapi.yaml</inputSpec>
                            <generatorName>spring</generatorName>
                            <importMappings>ZonedDateTime=java.time.ZonedDateTime</importMappings>
                            <typeMappings>
                                <typeMapping>DateTime=ZonedDateTime</typeMapping>
                                <typeMapping>URI=java.net.URL</typeMapping>
                            </typeMappings>
                            <configOptions>
                                <sourceFolder>mininskrivningsstatus</sourceFolder>
                                <useSpringBoot3>true</useSpringBoot3>
                                <hateoas>false</hateoas>
                                <interfaceOnly>true</interfaceOnly>
                                <apiPackage>se.jobtechdev.mininskrivningsstatus.api.generated.api</apiPackage>
                                <modelPackage>se.jobtechdev.mininskrivningsstatus.api.generated.model</modelPackage>
                                <dateLibrary>java8</dateLibrary>
                            </configOptions>
                            <supportingFilesToGenerate>ApiUtil.java</supportingFilesToGenerate>
                        </configuration>
                    </execution>
                    <execution>
                        <id>rask</id>
                        <goals>
                            <goal>generate</goal>
                        </goals>
                        <configuration>
                            <inputSpec>${project.basedir}/src/main/resources/rask.json</inputSpec>
                            <generatorName>java</generatorName>
                            <configOptions>
                                <library>apache-httpclient</library>
                                <sourceFolder>rask</sourceFolder>
                                <java8>true</java8>
                                <dateLibrary>java8</dateLibrary>
                                <apiPackage>se.arbetsformedlingen.rask.api</apiPackage>
                                <modelPackage>se.arbetsformedlingen.rask.model</modelPackage>
                                <invokerPackage>se.arbetsformedlingen.rask.client</invokerPackage>
                                <useRuntimeException>true</useRuntimeException>
                                <useJakartaEe>true</useJakartaEe>
                            </configOptions>
                            <supportingFilesToGenerate>
                                ApiClient.java,Pair.java,ApiException.java,ApiResponse.java,Authentication.java,JavaTimeFormatter.java,ServerConfiguration.java,ServerVariable.java,RFC3339DateFormat.java,StringUtil.java,BaseApi.java,Configuration.java
                            </supportingFilesToGenerate>
                            <generateApiDocumentation>false</generateApiDocumentation>
                            <generateApiTests>false</generateApiTests>
                            <generateModelDocumentation>false</generateModelDocumentation>
                            <generateModelTests>false</generateModelTests>
                        </configuration>
                    </execution>
                </executions>
            </plugin>
            <plugin>
                <groupId>org.codehaus.mojo</groupId>
                <artifactId>build-helper-maven-plugin</artifactId>
                <version>3.6.0</version>
                <executions>
                    <execution>
                        <id>add-openapitools-generated-sources</id>
                        <phase>generate-sources</phase>
                        <goals>
                            <goal>add-source</goal>
                        </goals>
                        <configuration>
                            <sources>
                                <source>target/generated-sources/openapi/mininskrivningsstatus</source>
                                <source>target/generated-sources/openapi/rask</source>
                            </sources>
                        </configuration>
                    </execution>
                </executions>
            </plugin>
        </plugins>
    </build>
</project>
